## sash 2.1

=== Makefile ===
#
# Makefile for sash
#

CFLAGS = -O3 -Wall -DHAVE_GZIP
LDFLAGS = -static -s
LIBS = -lz


BINDIR = /bin
MANDIR = /usr/man/man1


OBJS = sash.o cmds.o cmd_dd.o cmd_ed.o cmd_grep.o cmd_ls.o cmd_tar.o \
	cmd_gzip.o utils.o


sash:	$(OBJS)
	cc $(LDFLAGS) -o sash $(OBJS) $(LIBS)

clean:
	rm -f $(OBJS) sash

install: sash
	cp sash $(BINDIR)/sash
	cp sash.1 $(MANDIR)/sash.1

$(OBJS):	sash.h

## sash 3.4

=== Makefile ===
#
# Makefile for sash
#
# The HAVE_GZIP definition adds the -gzip and -gunzip commands.
# The HAVE_EXT2 definition adds the -chattr and -lsattr comamnds.
#

CFLAGS = -O3 -Wall -Wmissing-prototypes -DHAVE_GZIP -DHAVE_EXT2
LDFLAGS = -static -s
LIBS = -lz


BINDIR = /bin
MANDIR = /usr/man/man1


OBJS = sash.o cmds.o cmd_dd.o cmd_ed.o cmd_grep.o cmd_ls.o cmd_tar.o \
	cmd_gzip.o cmd_find.o cmd_file.o cmd_chattr.o cmd_ar.o utils.o


sash:	$(OBJS)
	$(CC) $(LDFLAGS) -o sash $(OBJS) $(LIBS)

clean:
	rm -f $(OBJS) sash

install: sash
	cp sash $(BINDIR)/sash
	cp sash.1 $(MANDIR)/sash.1

$(OBJS):	sash.h

## sash 3.7

=== Makefile ===
--- 
+++ 
@@ -2,10 +2,25 @@
 # Makefile for sash
 #
 # The HAVE_GZIP definition adds the -gzip and -gunzip commands.
-# The HAVE_EXT2 definition adds the -chattr and -lsattr comamnds.
+# The HAVE_LINUX_ATTR definition adds the -chattr and -lsattr commands.
+# The HAVE_LINUX_MOUNT definition makes -mount and -umount work on Linux.
+# The HAVE_BSD_MOUNT definition makes -mount and -umount work on BSD.
+# The MOUNT_TYPE definition sets the default file system type for -mount.
 #
+HAVE_GZIP		= 1
+HAVE_LINUX_ATTR		= 1
+HAVE_LINUX_MOUNT	= 1
+HAVE_BSD_MOUNT		= 0
+MOUNT_TYPE		= '"ext3"'
 
-CFLAGS = -O3 -Wall -Wmissing-prototypes -DHAVE_GZIP -DHAVE_EXT2
+
+CFLAGS = -O3 -Wall -Wmissing-prototypes \
+	-DHAVE_GZIP=$(HAVE_GZIP) \
+	-DHAVE_LINUX_ATTR=$(HAVE_LINUX_ATTR) \
+	-DHAVE_LINUX_MOUNT=$(HAVE_LINUX_MOUNT) \
+	-DHAVE_BSD_MOUNT=$(HAVE_BSD_MOUNT) \
+	-DMOUNT_TYPE=$(MOUNT_TYPE)
+
 LDFLAGS = -static -s
 LIBS = -lz

=== debian/changelog ===
sash (3.7-13) unstable; urgency=low

  * Update to debhelper compat version 9, which adds hardening.
  * Update to newer Standards-Version, add Built-Using field.

 -- Tollef Fog Heen <tfheen@debian.org>  Sun, 29 Sep 2013 16:11:22 +0200

sash (3.7-12) unstable; urgency=low

  * Update lintian overrides for new names.

 -- Tollef Fog Heen <tfheen@debian.org>  Mon, 09 Apr 2012 10:34:04 +0200

sash (3.7-11) unstable; urgency=low

  * Update to dh version 8
  * Add dh_buildflags support, closes: #654909
  * Update FreeBSD build patch.  Closes: #565539

 -- Tollef Fog Heen <tfheen@debian.org>  Mon, 09 Apr 2012 09:11:01 +0200

sash (3.7-10) unstable; urgency=low

  * Switch to 3.0 (quilt) as the source format and convert patches.
  * Fix up debian/patches/touch_error_handling to actually update the
    timestamp of the file, something that has been broken for more than
    ten years.
  * Add kFreeBSD build fixes from Axel Beckert. Closes: #565539
  * When exiting the shell, use the exit status of the last command as our
    exit status.  Closes: #281728

 -- Tollef Fog Heen <tfheen@debian.org>  Sun, 04 Apr 2010 10:25:57 +0200

sash (3.7-9) unstable; urgency=low

  * Drop dependency on lockfile-progs, no longer needed.
  * Drop versioned dependency on passwd, that version is pre-oldstable
  * Drop versioned conflicts on fileutils, that version is pre-oldstable.
  * Move to debhelper 7 instead of cdbs.
  * Add missing set -e to postrm.
  * Drop full paths to add-shell and remove-shell.
  * Add lintian override for embedded zlib.

 -- Tollef Fog Heen <tfheen@debian.org>  Fri, 09 Oct 2009 09:15:48 +0200

sash (3.7-8) unstable; urgency=medium

  * Get rid of the sashroot account and all debconfiscation (but don't
    change already-set up systems).
    Closes: #410758, #400892, #482900, #489380
  * Unconditionally remove sashroot when removing the package.  
    Closes: #464610
  * Call add-shell when upgrading from etch or older.  Closes: #416059.
  * Remove -s from LDFLAGS.  Closes: #437952
  * Stop setting PATH in postinst.
  * Update to newest policy version
    - Add Homepage field.

 -- Tollef Fog Heen <tfheen@debian.org>  Mon, 21 Jul 2008 13:45:15 +0200

sash (3.7-7.3) unstable; urgency=low

  * Non-maintainer upload to fix pending l10n issues
  * Debconf translations:
    - Dutch. Closes: #414751
    - Spanish. Closes: #415201
    - French converted to UTF-8
    - Finnish. Closes: #472616
    - Basque. Closes: #475359
    - Galician. Closes: #475462
  * [Lintian] Change menu entry to Applications/Shells
  * Upgrade Standards from 3.6.1 to 3.7.3 (checked)

 -- Christian Perrier <bubulle@debian.org>  Tue, 25 Mar 2008 18:23:28 +0100

sash (3.7-7.2) unstable; urgency=low

  * NMU
  * Apparently CDBS decided to start overwriting the LDFLAGS setting, which
    made sash no longer statically linked. Work around this brain-damage.
    Closes: #403659

 -- Joey Hess <joeyh@debian.org>  Tue, 19 Dec 2006 18:16:21 -0500

sash (3.7-7.1) unstable; urgency=low

  * Non-maintainer upload to fix longstanding l10n issues
  * Rewrite templates to better fit the Developer's Reference recommendations
    This also Closes: #368750
  * Debconf translation updates:
    - Swedish added. Closes: #338776
    - French updated. Sent during the call for updates of the NMU campaign.
    - Vietnamese updated. Sent during the call for updates of the NMU campaign.
    - Dzongkha added. Sent during the call for updates of the NMU campaign.
    - German added. Sent during the call for updates of the NMU campaign.
    - Russian added. Sent during the call for updates of the NMU campaign.

 -- Christian Perrier <bubulle@debian.org>  Wed, 29 Nov 2006 07:40:31 +0100

sash (3.7-7) unstable; urgency=low

  * Remove /usr/doc/sash symlink if it exists.  (closes: #322797)
  * Fix up debconf dependency, we want debconf | debconf-2.0

 -- Tollef Fog Heen <tfheen@debian.org>  Thu,  1 Sep 2005 07:52:20 +0200

sash (3.7-6) unstable; urgency=high

  * Tighten zlib build-deps to fix security issue (closes: #318069)
  * Add Czech debconf translation (closes: #294777)
  * Add Vietnamese debconf translation (closes: #317886)

 -- Tollef Fog Heen <tfheen@debian.org>  Thu, 14 Jul 2005 12:33:51 +0200

sash (3.7-5) unstable; urgency=low

  * Add Japanese debconf translation (closes: #290129)
  * Add German debconf translation (closes: #266357)

 -- Tollef Fog Heen <tfheen@debian.org>  Sat,  5 Feb 2005 12:57:59 +0100

sash (3.7-4) unstable; urgency=low

  * Add French debconf translation (closes: #232979)
  * Add lintian override (closes: #235306)

 -- Tollef Fog Heen <tfheen@debian.org>  Thu,  1 Apr 2004 03:42:48 +0200

sash (3.7-3) unstable; urgency=low

  * Use po-debconf.

 -- Tollef Fog Heen <tfheen@debian.org>  Tue, 10 Feb 2004 03:12:41 +0100

sash (3.7-2) unstable; urgency=low

  * Fix versioned depends on passwd.  (closes: #229192)

 -- Tollef Fog Heen <tfheen@debian.org>  Fri, 23 Jan 2004 17:57:59 +0100

sash (3.7-1) unstable; urgency=low

  * New upstream release
    - Fixes (closes: #227164)
  * Only ask about deleting sashroot account if it's actually
    created. (closes: #225341)
  * Ask about removing sashroot user in prerm instead of when
    installing. (closes: #227637)

 -- Tollef Fog Heen <tfheen@debian.org>  Tue, 13 Jan 2004 00:41:55 +0100

sash (3.6-5) unstable; urgency=low

  * Remove -m call to useradd.  (closes: #225093)
  * Up standards-version.

 -- Tollef Fog Heen <tfheen@debian.org>  Fri, 26 Dec 2003 22:57:29 +0100

sash (3.6-4) unstable; urgency=medium

  * Use chown root:shadow instead of root.shadow in sashconfig
    (closes: #217395)
  * Depend on passwd (>= 20000902-12) (closes: #219961)
  * Use debconf. (closes: #86208, #96566)
    - Thereby getting rid of sashconfig.  Yay.
  * Build-dep on e2fslibs-dev, since it seems like libc6 broke us. 
    (closes: #223203)

 -- Tollef Fog Heen <tfheen@debian.org>  Wed, 17 Dec 2003 23:00:13 +0100

sash (3.6-3) unstable; urgency=low



=== debian/control ===
Source: sash
Section: shells
Priority: optional
Maintainer: Tollef Fog Heen <tfheen@debian.org>
Standards-Version: 3.9.4
Build-Depends: zlib1g-dev (>= 1:1.2.2-7), debhelper (>= 9),
 e2fslibs-dev [!kfreebsd-amd64 !kfreebsd-i386],
 kfreebsd-kernel-headers [kfreebsd-amd64 kfreebsd-i386]

Package: sash
Architecture: any
Section: shells
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: doc-debian
Built-Using: ${built-using}
Description: Stand-alone shell
 sash serves as an interactive substitute for /bin/sh, for use when
 /bin/sh is unusable.  It's statically linked, and includes many standard
 utilities as builtins (type "help" at the prompt for a reference list).
 If you've installed sash before rendering your system unbootable, and
 you have some knowledge of how your system is supposed to work, you might
 be able to repair your system using init=/bin/sash at the boot prompt.
 .
 Some people also prefer to have sash available as the shell for a
 root account (perhaps an under an alternate name such as sashroot)
 Configuration support is included for people who want this.  
 .
 Note: sash is not intended to serve as /bin/sh, and has few of the
 interactive features present in bash or ksh.  It's designed to be simple
 and robust, for people who need to do emergency repair work on a system.
 .
 Also note: sash doesn't include a built-in fsck -- fsck is too big
 and complicated.  If you need fsck, you'll have to get at least one
 partition or disk working well enough to run fsck.  More generally,
 sash is but one tool of many (backups, backup recovery tools, emergency
 boot disks or partitions, spare parts, testing of disaster plans,
 etc.) to help you recover a damaged system.
Homepage: http://members.tip.net.au/~dbell/

=== debian/rules ===
#! /usr/bin/make -f

pkgdir := `pwd`/debian/sash

BUILT_USING := $(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W zlib1g-dev libc6-dev)

%:
	dh $@

override_dh_auto_build:
	$(MAKE) CFLAGS="`dpkg-buildflags --get CFLAGS` `dpkg-buildflags --get CPPFLAGS`" LDFLAGS="-static `dpkg-buildflags --get LDFLAGS`"

override_dh_auto_install:
	make install BINDIR=$(pkgdir)/bin MANDIR=$(pkgdir)/usr/share/man/man1

override_dh_install:
	dh_install
	install -m 0644 debian/lintian-overrides $(pkgdir)/usr/share/lintian/overrides/sash

override_dh_gencontrol:
	dh_gencontrol -- -V"built-using=$(BUILT_USING)"

## sash 3.8

=== Makefile ===
#
# Makefile for sash
#
# The HAVE_GZIP definition adds the -gzip and -gunzip commands.
# The HAVE_LINUX_ATTR definition adds the -chattr and -lsattr commands.
# The HAVE_LINUX_CHROOT definition adds the -chroot command.
# The HAVE_LINUX_PIVOT definition adds the -pivot_root command.
# The HAVE_LINUX_LOSETUP definition adds the -losetup command.
# The HAVE_LINUX_MOUNT definition makes -mount and -umount work on Linux.
# The HAVE_BSD_MOUNT definition makes -mount and -umount work on BSD.
# The MOUNT_TYPE definition sets the default file system type for -mount.
#
# Note that the linker may show warnings about 'statically linked
# programs' requiring getpwnam, getpwuid, getgrnam and getgrgid.
# This is unavoidable since those routines use dynamic libraries anyway.
# Sash will still run, but if there are shared library problems then
# the user might have to be be careful when using the -chown, -chgrp,
# and -ls commands.
#

HAVE_GZIP		= 1
HAVE_LINUX_ATTR		= 1
HAVE_LINUX_CHROOT	= 1
HAVE_LINUX_LOSETUP	= 1
HAVE_LINUX_PIVOT	= 1
HAVE_LINUX_MOUNT	= 1
HAVE_BSD_MOUNT		= 0
MOUNT_TYPE		= '"ext3"'

OPT = -O3

CFLAGS = $(OPT) -Wall -Wmissing-prototypes \
	-DHAVE_GZIP=$(HAVE_GZIP) \
	-DHAVE_LINUX_ATTR=$(HAVE_LINUX_ATTR) \
 	-DHAVE_LINUX_CHROOT=$(HAVE_LINUX_CHROOT) \
 	-DHAVE_LINUX_LOSETUP=$(HAVE_LINUX_LOSETUP) \
 	-DHAVE_LINUX_PIVOT=$(HAVE_LINUX_PIVOT) \
	-DHAVE_LINUX_MOUNT=$(HAVE_LINUX_MOUNT) \
	-DHAVE_BSD_MOUNT=$(HAVE_BSD_MOUNT) \
	-DMOUNT_TYPE=$(MOUNT_TYPE)

LDFLAGS = -static
LIBS = -lz


DESTDIR =
BINDIR = /bin
MANDIR = /usr/man


OBJS = sash.o cmds.o cmd_dd.o cmd_ed.o cmd_grep.o cmd_ls.o cmd_tar.o \
	cmd_gzip.o cmd_find.o cmd_file.o cmd_chattr.o cmd_ar.o utils.o


sash:	$(OBJS)
	$(CC) $(LDFLAGS) -o sash $(OBJS) $(LIBS)
	strip sash

clean:
	rm -f $(OBJS) sash

install: sash
	cp sash $(DESTDIR)/$(BINDIR)/sash
	cp sash.1 $(DESTDIR)/$(MANDIR)/man1/sash.1

$(OBJS):	sash.h

=== debian/changelog ===
sash (3.8-7) unstable; urgency=medium

  * Move zlib1g-dev to Static-Built-Using.
  * Fix generating Built-Using for glibc. (Closes: #1106806)

 -- Marco d'Itri <md@linux.it>  Tue, 03 Jun 2025 04:08:45 +0200

sash (3.8-6) unstable; urgency=medium

  * Adopt the package.
  * Implement tab completion and history. (Closes: #171108)
  * Implement the raidautorun builtin command.
  * Add support for using sash as a #! interpreter.
  * Have mount default to ext4 instead of ext3.
  * Fix the semantics of the where builtin command when there are empty
    elements in the $PATH.

 -- Marco d'Itri <md@linux.it>  Mon, 22 Jul 2024 00:27:30 +0200

sash (3.8-5.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Move sash to /usr/bin/. (Closes: #1073672)
  * Remove the debconfiscation about the sashroot account, which has
    not been created anymore since sash 3.7-8 released in 2008.
    (Closes: #913933, #1050110, #903861)

 -- Marco d'Itri <md@linux.it>  Sun, 07 Jul 2024 17:25:41 +0200

sash (3.8-5) unstable; urgency=medium

  * Add German, French, Dutch, Russian and Portuguese Debconf
    translations. Closes: #869137, #872356, #874282, #883111, #898293

 -- Tollef Fog Heen <tfheen@debian.org>  Sat, 09 Jun 2018 22:33:23 +0200

sash (3.8-4) unstable; urgency=medium

  * Add debconf warning about sashroot user instead of trying to remove
    it, since userdel is unable to properly delete it.  Closes: #783031
  * Let dh_auto_build pass cross compilers.  Thanks to Helmut Grohne for
    patch.
  * Stop stripping during build.  Also thanks to Helmut Grohne.
    Closes: #852771

 -- Tollef Fog Heen <tfheen@debian.org>  Sun, 16 Jul 2017 19:13:30 +0200

sash (3.8-3) unstable; urgency=medium

  * Drop support for adosfs, mfs on FreeBSD.
  * Wrap inclusion on linux/loop.h to fix kFreeBSD build.

 -- Tollef Fog Heen <tfheen@debian.org>  Sat, 19 Jul 2014 11:40:36 +0200

sash (3.8-2) unstable; urgency=medium

  * Use #if instead of #ifdef for HAVE_LINUX_* in sash.c to make this
    build on kfreebsd.  Closes: #754669

 -- Tollef Fog Heen <tfheen@debian.org>  Wed, 16 Jul 2014 20:48:59 +0200

sash (3.8-1) unstable; urgency=medium

  * New upstream version.
  * Use grep-status to pull out package name of what provides libc-dev and
    use that when filling out built-using.  Closes: #733570

 -- Tollef Fog Heen <tfheen@debian.org>  Sun, 20 Apr 2014 08:23:04 +0200

=== debian/control ===
Source: sash
Section: shells
Priority: optional
Maintainer: Marco d'Itri <md@linux.it>
Standards-Version: 4.7.0.0
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 zlib1g-dev,
 libext2fs-dev [linux-any],
Homepage: https://members.tip.net.au/~dbell/
Vcs-Git: https://salsa.debian.org/md/sash.git
Vcs-Browser: https://salsa.debian.org/md/sash

Package: sash
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Built-Using: ${built-using}
Static-Built-Using: ${static-built-using}
Description: Stand-alone statically linked shell
 sash serves as an interactive substitute for /bin/sh, for use when
 /bin/sh is unusable.  It's statically linked, and includes many standard
 utilities as builtins (type "help" at the prompt for a reference list).
 If you've installed sash before rendering your system unbootable, and
 you have some knowledge of how your system is supposed to work, you might
 be able to repair your system using init=/bin/sash at the boot prompt.
 .
 Note: sash is not intended to serve as /bin/sh, and has few of the
 interactive features present in bash or ksh.  It's designed to be simple
 and robust, for people who need to do emergency repair work on a system.
 .
 Also note: sash doesn't include a built-in fsck -- fsck is too big
 and complicated.  If you need fsck, you'll have to get at least one
 partition or disk working well enough to run fsck.  More generally,
 sash is but one tool of many (backups, backup recovery tools, emergency
 boot disks or partitions, spare parts, testing of disaster plans,
 etc.) to help you recover a damaged system.

=== debian/rules ===
#! /usr/bin/make -f

BUILT_USING := $(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W libc-dev-bin)
STATIC_BUILT_USING := $(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W zlib1g-dev)

%:
	dh $@

override_dh_gencontrol:
	dh_gencontrol -- \
		-V"built-using=$(BUILT_USING)" \
		-V"static-built-using=$(STATIC_BUILT_USING)"
